; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1+TEMP2															
ZAHL_GRUEN_TEMP1_2:
	tst temp1
	brne ZAHL_GRUEN_START
	tst temp2
	brne ZAHL_GRUEN_START
	ldi temp,(ASCII_PUNKT)
	STS(adr_LED_BYTE_2),temp
	STS(adr_LED_BYTE_1),temp
	STS(adr_LED_BYTE_0),temp
ret
;-------------------------------------------------------------------------------
ZAHL_GRUEN_START:
	cpi temp2,high(999)
	breq ZAHL_GRUEN_L
	brsh ZAHL_GRUEN_ERROR
	brlo ZAHL_GRUEN_RUN
;-------------------------------------------------------------------------------
ZAHL_GRUEN_L:
	cpi temp1,low(999)
	breq ZAHL_GRUEN_RUN
	brsh ZAHL_GRUEN_ERROR
	brlo ZAHL_GRUEN_RUN
;-------------------------------------------------------------------------------
ZAHL_GRUEN_ERROR:
	rcall ZAHL_HEX_GRUEN_TEMP1_2
	ret
;-------------------------------------------------------------------------------
ZAHL_GRUEN_RUN:
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32
	STS(adr_LED_BYTE_2),temp3			;  100-er Stelle	
	STS(adr_LED_BYTE_1),temp2			;   10-er Stelle	
	STS(adr_LED_BYTE_0),temp1			;    1-er Stelle	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZAHL_HEX_GRUEN_TEMP1_2:
	mov temp,TEMP2
	rcall ZAHL_HEX_TEMP
	STS(adr_LED_BYTE_2),temp

	mov temp,TEMP1
	swap temp
	andi temp,0b00001111
	rcall ZAHL_HEX_TEMP
	STS(adr_LED_BYTE_1),temp

	mov temp,TEMP1
	andi temp,0b00001111
	rcall ZAHL_HEX_TEMP
	STS(adr_LED_BYTE_0),temp

	LDS temp,(adr_LED_BYTE_2)			; PUNKT			
	ori temp,0b10000000
	STS(adr_LED_BYTE_2),temp

	LDS temp,(adr_LED_BYTE_1)			; PUNKT			
	ori temp,0b10000000
	STS(adr_LED_BYTE_1),temp

	LDS temp,(adr_LED_BYTE_0)			; PUNKT			
	ori temp,0b10000000
	STS(adr_LED_BYTE_0),temp


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZAHL_HEX_ROT_TEMP1_2:
	mov temp,TEMP2
	rcall ZAHL_HEX_TEMP
	STS(adr_LED_BYTE_5),temp			;  100-er Stelle	

	mov temp,TEMP1
	swap temp
	andi temp,0b00001111
	rcall ZAHL_HEX_TEMP
	STS(adr_LED_BYTE_4),temp			;   10-er Stelle	

	mov temp,TEMP1
	andi temp,0b00001111
	rcall ZAHL_HEX_TEMP
	STS(adr_LED_BYTE_3),temp			;    1-er Stelle	



	LDS temp,(adr_LED_BYTE_5)			; PUNKT			
	ori temp,0b10000000
	STS(adr_LED_BYTE_5),temp

	LDS temp,(adr_LED_BYTE_4)			; PUNKT			
	ori temp,0b10000000
	STS(adr_LED_BYTE_4),temp

	LDS temp,(adr_LED_BYTE_3)			; PUNKT			
	ori temp,0b10000000
	STS(adr_LED_BYTE_3),temp


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZAHL_HEX_TEMP:
	cpi  temp,0
	breq ZAHL_HEX_0
	cpi  temp,1
	breq ZAHL_HEX_1
	cpi  temp,2
	breq ZAHL_HEX_2
	cpi  temp,3
	breq ZAHL_HEX_3
	cpi  temp,4
	breq ZAHL_HEX_4
	cpi  temp,5
	breq ZAHL_HEX_5
	cpi  temp,6
	breq ZAHL_HEX_6
	cpi  temp,7
	breq ZAHL_HEX_7
	cpi  temp,8
	breq ZAHL_HEX_8
	cpi  temp,9
	breq ZAHL_HEX_9
	cpi  temp,10
	breq ZAHL_HEX_A
	cpi  temp,11
	breq ZAHL_HEX_B
	cpi  temp,12
	breq ZAHL_HEX_C
	cpi  temp,13
	breq ZAHL_HEX_D
	cpi  temp,14
	breq ZAHL_HEX_E
	rjmp ZAHL_HEX_F
ZAHL_HEX_0:
	ldi temp,(ASCII_0)
	ret
ZAHL_HEX_1:
	ldi temp,(ASCII_1)
	ret
ZAHL_HEX_2:
	ldi temp,(ASCII_2)
	ret
ZAHL_HEX_3:
	ldi temp,(ASCII_3)
	ret
ZAHL_HEX_4:
	ldi temp,(ASCII_4)
	ret
ZAHL_HEX_5:
	ldi temp,(ASCII_5)
	ret
ZAHL_HEX_6:
	ldi temp,(ASCII_6)
	ret
ZAHL_HEX_7:
	ldi temp,(ASCII_7)
	ret
ZAHL_HEX_8:
	ldi temp,(ASCII_8)
	ret
ZAHL_HEX_9:
	ldi temp,(ASCII_9)
	ret

ZAHL_HEX_A:
	ldi temp,(ASCII_A)
	ret
ZAHL_HEX_B:
	ldi temp,(ASCII_B)
	ret
ZAHL_HEX_C:
	ldi temp,(ASCII_C)
	ret
ZAHL_HEX_D:
	ldi temp,(ASCII_D)
	ret
ZAHL_HEX_E:
	ldi temp,(ASCII_D)
	ret
ZAHL_HEX_F:
	ldi temp,(ASCII_F)
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1+TEMP2															
ZAHL_ROT_TEMP1_2:
	tst temp1
	brne ZAHL_ROT_START
	tst temp2
	brne ZAHL_ROT_START
	ldi temp,(ASCII_PUNKT)
	STS(adr_LED_BYTE_5),temp
	STS(adr_LED_BYTE_4),temp
	STS(adr_LED_BYTE_3),temp
ret
;-------------------------------------------------------------------------------
ZAHL_ROT_START:
	cpi temp2,high(999)
	breq ZAHL_ROT_L
	brsh ZAHL_ROT_ERROR
	brlo ZAHL_ROT_RUN
;-------------------------------------------------------------------------------
ZAHL_ROT_L:
	cpi temp1,low(999)
	breq ZAHL_ROT_RUN
	brsh ZAHL_ROT_ERROR
	brlo ZAHL_ROT_RUN
;-------------------------------------------------------------------------------
ZAHL_ROT_ERROR:
	rcall ZAHL_HEX_ROT_TEMP1_2
	ret
;-------------------------------------------------------------------------------
ZAHL_ROT_RUN:
	clr temp3
	clr temp4
 	rcall FUNKTION_HEX_ASC_32
	STS(adr_LED_BYTE_5),temp3			;  100-er Stelle	
	STS(adr_LED_BYTE_4),temp2			;   10-er Stelle	
	STS(adr_LED_BYTE_3),temp1			;    1-er Stelle	
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; STAND: 05.11.2015															
;																			
;	Value: 0...	4.294.967.295 (FFFFFFFF)									
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		     1-er Stelle)								
;			temp2	(		    10-er Stelle)								
;			temp3	(          100-er Stelle)								
;			temp4	(        1.000-er Stelle)								
;			temp5	(       10.000-er Stelle)								
;			temp6	(      100.000-er Stelle)								
;			temp7	(    1.000.000-er Stelle)								
;			temp8	(   10.000.000-er Stelle)								
;			temp9	(  100.000.000-er Stelle)								
;			R0	   (1.000.000.000-er Stelle)								
; 																			
FUNKTION_HEX_ASC_32:
;---------------------------------------------------------------------------
	clr temp			
FUNKTION_HEX_ASC_109:	; 1.100.000.000
	inc temp
	subi temp1, BYTE1    (1000000000)
	sbci temp2, BYTE2    (1000000000)
	sbci temp3, BYTE3    (1000000000)
	sbci temp4, BYTE4    (1000000000)
	brcc FUNKTION_HEX_ASC_109
	subi temp, (-48+1)	; HEX->ASC	
	mov R0,temp
	subi temp1, BYTE1   (-1000000000)
	sbci temp2, BYTE2   (-1000000000)
	sbci temp3, BYTE3   (-1000000000)
	sbci temp4, BYTE4   (-1000000000)
;---------------------------------------------------------------------------
	clr temp9			
FUNKTION_HEX_ASC_108:	; 100.000.000
	inc temp9
	subi temp1, BYTE1    (100000000)
	sbci temp2, BYTE2    (100000000)
	sbci temp3, BYTE3    (100000000)
	sbci temp4, BYTE4    (100000000)
	brcc FUNKTION_HEX_ASC_108
	subi temp9, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000000)
	sbci temp2, BYTE2   (-100000000)
	sbci temp3, BYTE3   (-100000000)
	sbci temp4, BYTE4   (-100000000)
;---------------------------------------------------------------------------
	clr temp8
FUNKTION_HEX_ASC_107:	; 10.000.000
	inc temp8
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_107
	subi temp8, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
;---------------------------------------------------------------------------
	clr temp7
FUNKTION_HEX_ASC_106:	; 1.000.000
	inc temp7
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_106
	subi temp7, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
;---------------------------------------------------------------------------
	clr temp6
FUNKTION_HEX_ASC_105:	; 100.000	
	inc temp6
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_105
	subi temp6, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
;---------------------------------------------------------------------------
	clr temp5
FUNKTION_HEX_ASC_104:	; 10.000	
	inc temp5
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_104
	subi temp5, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
;---------------------------------------------------------------------------
	clr temp4
FUNKTION_HEX_ASC_103:	; 1.000		
	inc temp4
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_103
	subi temp4, (-48+1)	; HEX->ASC	
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
;---------------------------------------------------------------------------
	clr temp3
FUNKTION_HEX_ASC_102:	; 100		
	inc temp3
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_102
	subi temp3, (-48+1)	; HEX->ASC	
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
;---------------------------------------------------------------------------
	clr temp2
FUNKTION_HEX_ASC_101:	; 10		
	inc temp2
	subi temp1, low  (10)
	brcc FUNKTION_HEX_ASC_101
	subi temp2, (-48+1)	; HEX->ASC	
	subi temp1, low  (-10)
;---------------------------------------------------------------------------
FUNKTION_HEX_ASC_100:	; 1			
	subi temp1, -48		; HEX->ASC
;---------------------------------------------------------------------------
; auf 7 SEGNMENT															
	mov temp,temp1
	rcall FUNKTION_7_SEGMENT
	mov temp1,temp

	mov temp,temp2
	rcall FUNKTION_7_SEGMENT
	mov temp2,temp


	mov temp,temp3
	rcall FUNKTION_7_SEGMENT
	mov temp3,temp

	mov temp,temp4
	rcall FUNKTION_7_SEGMENT
	mov temp4,temp

	mov temp,temp5
	rcall FUNKTION_7_SEGMENT
	mov temp5,temp

	mov temp,temp6
	rcall FUNKTION_7_SEGMENT
	mov temp6,temp

	mov temp,temp7
	rcall FUNKTION_7_SEGMENT
	mov temp7,temp

	mov temp,temp8
	rcall FUNKTION_7_SEGMENT
	mov temp8,temp

	mov temp,temp9
	rcall FUNKTION_7_SEGMENT
	mov temp9,temp

	mov temp,R0
	rcall FUNKTION_7_SEGMENT
	mov R0,temp
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
FUNKTION_7_SEGMENT:
	cpi temp,'0'
	brne FUNKTION_7_SEGMENT_1
	ldi temp, (ASCII_0)
	ret
FUNKTION_7_SEGMENT_1:
	cpi temp,'1'
	brne FUNKTION_7_SEGMENT_2
	ldi temp, (ASCII_1)
	ret
FUNKTION_7_SEGMENT_2:
	cpi temp,'2'
	brne FUNKTION_7_SEGMENT_3
	ldi temp, (ASCII_2)
	ret
FUNKTION_7_SEGMENT_3:
	cpi temp,'3'
	brne FUNKTION_7_SEGMENT_4
	ldi temp, (ASCII_3)
	ret
FUNKTION_7_SEGMENT_4:
	cpi temp,'4'
	brne FUNKTION_7_SEGMENT_5
	ldi temp, (ASCII_4)
	ret
FUNKTION_7_SEGMENT_5:
	cpi temp,'5'
	brne FUNKTION_7_SEGMENT_6
	ldi temp, (ASCII_5)
	ret
FUNKTION_7_SEGMENT_6:
	cpi temp,'6'
	brne FUNKTION_7_SEGMENT_7
	ldi temp, (ASCII_6)
	ret
FUNKTION_7_SEGMENT_7:
	cpi temp,'7'
	brne FUNKTION_7_SEGMENT_8
	ldi temp, (ASCII_7)
	ret
FUNKTION_7_SEGMENT_8:
	cpi temp,'8'
	brne FUNKTION_7_SEGMENT_9
	ldi temp, (ASCII_8)
	ret
FUNKTION_7_SEGMENT_9:
	cpi temp,'9'
	brne FUNKTION_7_SEGMENT_ERROR
	ldi temp, (ASCII_9)
	ret
FUNKTION_7_SEGMENT_ERROR:
	; ERROR
	ldi temp, (ASCII_E)
	ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	

